// generated by Fast Light User Interface Designer (fluid) version 1.0105

#include "gui.h"

inline void KafkaUI::cb_L_i(Fl_Menu_*, void*) {
  SegmentVector linesA, linesB;
MorphInfo info;
info.linesA = &linesA;
info.linesB = &linesB;
char *filename = fl_file_chooser("Select a saved morph", "*.mrf", NULL);
if (filename != NULL)
{
	int retval = CMorphFile::Load(filename, &info);
	if (retval != 0)
	{
		fl_alert("Error loading file %s", filename);
		return;
	}
	m_morphView->DisperseMorphInfo(&info);
	TryInitializeOutputDimensions(CMorphView::IMG_A);	
}
m_morphView->redraw();
}
void KafkaUI::cb_L(Fl_Menu_* o, void* v) {
  ((KafkaUI*)(o->parent()->user_data()))->cb_L_i(o,v);
}

inline void KafkaUI::cb_Save_i(Fl_Menu_*, void*) {
  if (!m_morphView->IsReadyToMorph())
{
	fl_alert("You're not ready to morph yet!");
	return;
}

MorphInfo info;
info.warpFrac = 0.5f;
info.dissolveFrac = 0.5f;
info.morphParamA = 0.01f;
info.morphParamB = 2.0f;
info.morphParamP = 0.2f;
m_morphView->GatherMorphInfo(&info);

char *filename = fl_file_chooser("Select a destination", "*.mrf", NULL);
if (filename != NULL)
{
	int retval = CMorphFile::Save(filename, &info);
	if (retval != 0)
	{
		fl_alert("Error saving to file %s", filename);
		return;
	}
};
}
void KafkaUI::cb_Save(Fl_Menu_* o, void* v) {
  ((KafkaUI*)(o->parent()->user_data()))->cb_Save_i(o,v);
}

inline void KafkaUI::cb_E_i(Fl_Menu_*, void*) {
  exit(0);
}
void KafkaUI::cb_E(Fl_Menu_* o, void* v) {
  ((KafkaUI*)(o->parent()->user_data()))->cb_E_i(o,v);
}

inline void KafkaUI::cb_aboutMenuItem_i(Fl_Menu_*, void*) {
  m_aboutWindow->show();
}
void KafkaUI::cb_aboutMenuItem(Fl_Menu_* o, void* v) {
  ((KafkaUI*)(o->parent()->user_data()))->cb_aboutMenuItem_i(o,v);
}

Fl_Menu_Item KafkaUI::menu_[] = {
 {"&File", 0,  0, 0, 64, 0, 0, 14, 56},
 {"L&oad Morph...", 0x4006f,  (Fl_Callback*)KafkaUI::cb_L, 0, 0, 0, 0, 14, 56},
 {"&Save Morph...", 0x40073,  (Fl_Callback*)KafkaUI::cb_Save, 0, 0, 0, 0, 14, 56},
 {"E&xit", 0x8ffc1,  (Fl_Callback*)KafkaUI::cb_E, 0, 0, 0, 0, 14, 56},
 {0,0,0,0,0,0,0,0,0},
 {"&Help", 0,  0, 0, 64, 0, 0, 14, 56},
 {"&About Kafka...", 0,  (Fl_Callback*)KafkaUI::cb_aboutMenuItem, 0, 0, 0, 0, 14, 56},
 {0,0,0,0,0,0,0,0,0},
 {0,0,0,0,0,0,0,0,0}
};
Fl_Menu_Item* KafkaUI::fileMenu = KafkaUI::menu_ + 0;
Fl_Menu_Item* KafkaUI::helpMenu = KafkaUI::menu_ + 5;
Fl_Menu_Item* KafkaUI::aboutMenuItem = KafkaUI::menu_ + 6;

inline void KafkaUI::cb_m_loadImgAButton_i(Fl_Button*, void*) {
  TryLoadImage(CMorphView::IMG_A);
}
void KafkaUI::cb_m_loadImgAButton(Fl_Button* o, void* v) {
  ((KafkaUI*)(o->parent()->user_data()))->cb_m_loadImgAButton_i(o,v);
}

inline void KafkaUI::cb_m_loadImgBButton_i(Fl_Button*, void*) {
  TryLoadImage(CMorphView::IMG_B);
}
void KafkaUI::cb_m_loadImgBButton(Fl_Button* o, void* v) {
  ((KafkaUI*)(o->parent()->user_data()))->cb_m_loadImgBButton_i(o,v);
}

inline void KafkaUI::cb_m_createImageButton_i(Fl_Button*, void*) {
  if (!m_morphView->IsReadyToMorph())
{
	fl_alert("You're not ready to morph yet!");
	return;
}

MorphInfo info;
info.warpFrac = (float)m_outInterpSlider->value();
info.dissolveFrac = (float)m_outInterpSlider->value();
info.morphParamA = 0.01f;
info.morphParamB = 2.0f;
info.morphParamP = 0.2f;
info.outWidth  = (unsigned int)m_outWidth->value();
info.outHeight = (unsigned int)m_outHeight->value();
m_morphView->GatherMorphInfo(&info);

m_morpher.SetNumThreads(4);
int err = m_morpher.MorphInBackground(info);
if (err != 0)
{
	fl_alert("Morphing error!");
}
else
{
	// morph initiated successfully!
	SetIsActive(false);
	m_morpher.SetCompleteCallback(MorphCompleteCallback, this);
	// m_saveImgCButton->activate();
}
m_morphView->redraw();
}
void KafkaUI::cb_m_createImageButton(Fl_Button* o, void* v) {
  ((KafkaUI*)(o->parent()->user_data()))->cb_m_createImageButton_i(o,v);
}

inline void KafkaUI::cb_m_createMovieButton_i(Fl_Button*, void*) {
  if (!m_morphView->IsReadyToMorph())
{
	fl_alert("You're not ready to morph yet!");
	return;
}

fl_alert("This button is not yet implemented.  Sorry!");

/*
MorphInfo info;
info.warpFrac = 0.5f;
info.dissolveFrac = 0.5f;
info.morphParamA = 0.01f;
info.morphParamB = 2.0f;
info.morphParamP = 0.2f;
info.outWidth  = m_outWidth->value();
info.outHeight = m_outHeight->value();
m_morphView->GatherMorphInfo(&info);

m_morpher.SetNumThreads(4);
int err = m_morpher.MorphInBackground(info);
if (err != 0)
{
	fl_alert("Morphing error!");
}
else
{
	// morph initiated successfully!
	SetIsActive(false);
	m_morpher.SetCompleteCallback(MorphCompleteCallback, this);
	// m_saveImgCButton->activate();
}
*/
m_morphView->redraw();
}
void KafkaUI::cb_m_createMovieButton(Fl_Button* o, void* v) {
  ((KafkaUI*)(o->parent()->user_data()))->cb_m_createMovieButton_i(o,v);
}

inline void KafkaUI::cb_m_saveImgCButton_i(Fl_Button*, void*) {
  TrySaveImage(CMorphView::IMG_OUT);
}
void KafkaUI::cb_m_saveImgCButton(Fl_Button* o, void* v) {
  ((KafkaUI*)(o->parent()->user_data()))->cb_m_saveImgCButton_i(o,v);
}

inline void KafkaUI::cb_m_toolAdd_i(Fl_Button*, void*) {
  ClearToolButtons();
m_toolAdd->value(1);
m_morphView->SetTool(CMorphView::TOOL_ADD);
}
void KafkaUI::cb_m_toolAdd(Fl_Button* o, void* v) {
  ((KafkaUI*)(o->parent()->user_data()))->cb_m_toolAdd_i(o,v);
}

inline void KafkaUI::cb_m_toolEdit_i(Fl_Button*, void*) {
  ClearToolButtons();
m_toolEdit->value(1);
m_morphView->SetTool(CMorphView::TOOL_EDIT);
}
void KafkaUI::cb_m_toolEdit(Fl_Button* o, void* v) {
  ((KafkaUI*)(o->parent()->user_data()))->cb_m_toolEdit_i(o,v);
}

inline void KafkaUI::cb_m_toolDelete_i(Fl_Button*, void*) {
  ClearToolButtons();
m_toolDelete->value(1);
m_morphView->SetTool(CMorphView::TOOL_DELETE);
}
void KafkaUI::cb_m_toolDelete(Fl_Button* o, void* v) {
  ((KafkaUI*)(o->parent()->user_data()))->cb_m_toolDelete_i(o,v);
}

inline void KafkaUI::cb_m_aboutOkayButton_i(Fl_Return_Button*, void*) {
  m_aboutWindow->hide();
}
void KafkaUI::cb_m_aboutOkayButton(Fl_Return_Button* o, void* v) {
  ((KafkaUI*)(o->parent()->user_data()))->cb_m_aboutOkayButton_i(o,v);
}

KafkaUI::KafkaUI() {
  Fl_Double_Window* w;
  { Fl_Double_Window* o = m_morphWindow = new Fl_Double_Window(895, 636, "Kafka");
    w = o;
    o->box(FL_UP_BOX);
    o->user_data((void*)(this));
    o->align(FL_ALIGN_CENTER);
    { Fl_Menu_Bar* o = new Fl_Menu_Bar(0, 0, 895, 30);
      o->menu(menu_);
    }
    { CMorphView* o = m_morphView = new CMorphView(45, 31, 850, 460);
      o->box(FL_EMBOSSED_FRAME);
      o->color(FL_BACKGROUND_COLOR);
      o->selection_color(FL_BACKGROUND_COLOR);
      o->labeltype(FL_NORMAL_LABEL);
      o->labelfont(0);
      o->labelsize(14);
      o->labelcolor(FL_BLACK);
      o->align(FL_ALIGN_CENTER);
      o->when(FL_WHEN_RELEASE);
    }
    { Fl_Button* o = m_loadImgAButton = new Fl_Button(155, 495, 100, 35, "Load Image A");
      o->callback((Fl_Callback*)cb_m_loadImgAButton);
    }
    { Fl_Button* o = m_loadImgBButton = new Fl_Button(405, 495, 100, 35, "Load Image B");
      o->callback((Fl_Callback*)cb_m_loadImgBButton);
    }
    { Fl_Button* o = m_createImageButton = new Fl_Button(710, 545, 155, 35, "Morph! (single frame)");
      o->tooltip("Runs the morph.");
      o->callback((Fl_Callback*)cb_m_createImageButton);
    }
    { Fl_Button* o = m_createMovieButton = new Fl_Button(710, 590, 155, 35, "Morph! (export movie)");
      o->tooltip("Runs the morph.");
      o->callback((Fl_Callback*)cb_m_createMovieButton);
      o->deactivate();
    }
    { Fl_Button* o = m_saveImgCButton = new Fl_Button(690, 495, 100, 35, "Save Image");
      o->callback((Fl_Callback*)cb_m_saveImgCButton);
      o->deactivate();
    }
    { Fl_Value_Input* o = m_outWidth = new Fl_Value_Input(640, 535, 50, 25, "Output Width");
      o->minimum(1);
      o->maximum(10000);
      o->step(1);
      o->value(1);
      o->deactivate();
    }
    { Fl_Value_Input* o = m_outHeight = new Fl_Value_Input(640, 565, 50, 25, "Output Height");
      o->minimum(1);
      o->maximum(10000);
      o->step(1);
      o->value(1);
      o->deactivate();
    }
    { Fl_Progress* o = m_morphProgressBar = new Fl_Progress(10, 545, 530, 35);
      o->selection_color((Fl_Color)181);
    }
    { Fl_Button* o = m_toolAdd = new Fl_Button(5, 35, 35, 35, "Add");
      o->value(1);
      o->shortcut(0x61);
      o->callback((Fl_Callback*)cb_m_toolAdd);
    }
    { Fl_Button* o = m_toolEdit = new Fl_Button(5, 80, 35, 35, "Edit");
      o->shortcut(0x65);
      o->callback((Fl_Callback*)cb_m_toolEdit);
    }
    { Fl_Button* o = m_toolDelete = new Fl_Button(5, 125, 35, 35, "Delete");
      o->shortcut(0x64);
      o->callback((Fl_Callback*)cb_m_toolDelete);
    }
    { Fl_Value_Slider* o = m_outInterpSlider = new Fl_Value_Slider(525, 595, 165, 35, "Output Interpolation");
      o->type(5);
      o->value(0.5);
      o->align(FL_ALIGN_LEFT);
    }
    Fl::focus(m_morphWindow);
    o->end();
    o->resizable(o);
  }
  { Fl_Double_Window* o = m_aboutWindow = new Fl_Double_Window(290, 80, "About Kafka");
    w = o;
    o->user_data((void*)(this));
    new Fl_Box(35, 15, 215, 25, "Kafka by Cort Stratton");
    { Fl_Return_Button* o = m_aboutOkayButton = new Fl_Return_Button(95, 45, 80, 25, "Close");
      o->callback((Fl_Callback*)cb_m_aboutOkayButton);
    }
    o->set_modal();
    o->end();
  }
}
#include "PixelMap.h"

void KafkaUI::TryLoadImage(const CMorphView::ImageID whichImage) {
  char *filename = fl_file_chooser("Select an image", CPixelMap::LOAD_SUFFIXES, NULL);
if (filename == NULL)
{
	return;
}
int err = 0;
err = m_morphView->OpenImage(whichImage, filename);
if (err != 0)
{
	return;
}
err = TryInitializeOutputDimensions(whichImage);
if (err != 0)
{
	return;
}
}

void KafkaUI::TrySaveImage(const CMorphView::ImageID whichImage) {
  char *filename = fl_file_chooser("Where would you live to save to?", CPixelMap::SAVE_SUFFIXES, NULL);
if (filename != NULL)
{
	m_morphView->SaveImage(whichImage, filename);
}
}

int KafkaUI::TryInitializeOutputDimensions(const CMorphView::ImageID whichImage) {
  int err = 0;

int outWidth, outHeight;
err = m_morphView->GetImageDimensions(whichImage, &outWidth, &outHeight);
if (err != 0)
{
	return err;
}

// Activate and initialize the output width and height fields, if
// they aren't already active.
if (m_outWidth->active() == 0)
{
	m_outWidth->activate();
	m_outWidth->value(m_outWidth->clamp(outWidth));
	m_outHeight->activate();
	m_outHeight->value(m_outHeight->clamp(outHeight));
}

return err;
}
#include "ImageMorpher.h"

float KafkaUI::GetMorphStatus(void) {
  float status = 0.0f;
m_morpher.GetMorphStatus(&status);
return status;
}

void KafkaUI::SetIsActive(const bool isActive) {
  if (isActive)
{
	m_morphView->activate();
	m_loadImgAButton->activate();
	m_loadImgBButton->activate();
	m_saveImgCButton->activate();
	m_createImageButton->activate();
	//m_createMovieButton->activate();
	m_outWidth->activate();
	m_outHeight->activate();
	m_outInterpSlider->activate();
}
else
{
	m_morphView->deactivate();
	m_loadImgAButton->deactivate();
	m_loadImgBButton->deactivate();
	m_saveImgCButton->deactivate();
	m_createImageButton->deactivate();
	//m_createMovieButton->deactivate();
	m_outWidth->deactivate();
	m_outHeight->deactivate();
	m_outInterpSlider->deactivate();
}
}

void KafkaUI::ClearToolButtons(void) {
  m_toolAdd->value(0);
m_toolEdit->value(0);
m_toolDelete->value(0);
}

void MorphCompleteCallback(void *arg) {
  KafkaUI *ui = (KafkaUI*)arg;
ui->SetIsActive(true);
}
