#pragma warning(push)
#pragma warning(disable: 4311 4312)
#include "gui.h"
#pragma warning(pop)

#include "fastmath.h"

namespace
{
    KafkaUI *ui = NULL;

    const float displayRefreshInterval = 0.1f;
    void DisplayRefreshCallback(void *arg)
    {
        Fl::add_timeout(displayRefreshInterval, DisplayRefreshCallback);
        float status = ui->GetMorphStatus();
        if (status > 0.0f)
        {
            ui->m_morphProgressBar->show();
            ui->m_morphProgressBar->minimum(0.0f);
            ui->m_morphProgressBar->maximum(1.0f);
            ui->m_morphProgressBar->value(ui->GetMorphStatus());
        }
        else
        {
            ui->m_morphProgressBar->hide();
        }
        ui->m_morphView->redraw();
    }
};

int main(int argc, char *argv[])
{
    // other initialization
    build_sqrt_table();

    ui = new KafkaUI;
    ui->m_morphWindow->show(argc, argv);
    Fl::add_timeout(displayRefreshInterval, DisplayRefreshCallback);
    return Fl::run();
}
